/*
 * cata3mx.java is an applet modified (by Pierre STOUFF) from cata3.java	
* to be used with Catastrophe_teacher, a HTML document by 
 * Lucien Dujardin
 * Lab. Parasitol.
 * Fac Pharmacie
 * BP 83
 * F - 59006 Lille Cedex
 * France
 *
 * ldujardi@phare.univ-lille2.fr
 *
 * third design for a catastrophe machine: move the mouse on the pink square, 
 * the bottom right rectangle turn blue or green. In the system box, the model is made of
 * a potential, a minimization of potential and a delay law
 */


import java.awt.Font;
import java.awt.Graphics;
import java.awt.Color;
import java.lang.Math;
import java.lang.String;

public class cata3mx extends java.applet.Applet {

	int  signd, col2, sign, sign1, a1, b1, col3, col4, compteur, compteur1, ymin, ymin1, ymin2, ycompteur;
	float a, b, d=0, col, col1, col0, col22, pot, pot1, xmouse, ymouse;

	float f( float col ) {
		return col * col * col * col + a * col * col + b * col;
	}
	float derivf( float col ) {
		return  4 * col * col * col + 2 * a * col  + b;
	}

	public void paint(Graphics g) {
		if(ycompteur==0){
			g.setColor(new java.awt.Color(0, col2, 250-col2));
			g.fillRect(250, 250, 250, 50);
		}
		else {
			g.setColor(new java.awt.Color(255, 255, 255));
			g.fillRect(250, 250, 250, 50);
			ycompteur=0;
		}
			
		g.setColor(new java.awt.Color(250, 125, 125));
		g.fillRect(0, 0, 250, 250);
		g.setColor(new java.awt.Color(175, 175, 175));
		g.fillRect(250, 0, 250, 250);
		g.setColor(new java.awt.Color(255, 255, 255));
		g.fillRect(0, 250, 250, 100);
		g.setColor(new java.awt.Color(255, 255, 255));
		g.fillRect(250, 300, 250, 50);
		g.setColor(new java.awt.Color(250, 0, 0));
			ymin=0;
			ycompteur=0;
			for (int col = -125 ; col < 125 ; col++) {
				g.drawLine(col + 375, 125 - (int)(f(col) / 1200000 ), col + 376, 125 - (int)(f(col + 1) / 1200000 ));
				g.drawLine(col + 375, 125 - (int)derivf(col) , col + 376, 126 - (int)derivf(col + 1));
				ymin1=125-(int) f(col)/1200000;
				if (ymin1>ymin){
					ymin=ymin1;
					col3=col2;
					col2=(int)col+125;
					if(col3!=col2 && ycompteur==0){
						ycompteur=ycompteur+1;
						ymin2=ymin1;
						col3=(int)col+125;
					}
 				}
			}
		g.drawLine (250, ymin , 500, ymin);
		g.setColor(new java.awt.Color(0, col2, 250-col2));

		/*g.drawLine(col2 + 250, 0 , col2 + 250, 250);  cette verticale est trop dcales... je n'ai pas russi  la faire concider avec une racine*/
		g.setColor(new java.awt.Color(0, col2, 250-col2));
		g.fillRect(250, 250, 250, 50);
		g.setColor(new java.awt.Color(255, 255, 255));
		g.fillRect(0, 250, 250, 100);
		g.setColor(new java.awt.Color(255, 255, 255));
		g.fillRect(250, 300, 250, 50);

		/* les lignes qui suivent ont t ajoutes*/
		Font polis1 = new Font ("Arial", Font.BOLD, 12);
		g.setFont (polis1);
		g.setColor(new java.awt.Color(0, 0, 0));
		g.drawString("u=", 10, 15);
		g.drawString((a1+""), 30, 15);
		g.drawString("v=", 160, 240);
		g.drawString((b1+""), 180, 240);
		g.setColor(new java.awt.Color(0, 228, 22));
		g.fillRect(450, 302, 48, 48);
		g.setColor(new java.awt.Color(0, 22, 228));
		g.fillRect(250, 302,48, 48);
		g.setColor(new java.awt.Color(0, 0, 0));
		Font polis2 = new Font ("Arial", Font.PLAIN, 12);
		g.setFont (polis2);
		g.drawString("Espace de contrle des paramtres u et v",10,125);
		g.drawString("morphologie (sortie) ", 310, 315);
		g.drawString("couleur = ( 0,",305, 330);
		g.drawString((col2+"")+", ", 385, 330);
		g.drawString(((250-col2)+"")+"  )", 415, 330);
		g.drawLine(375, 250, 375, 0);
		g.drawLine(250, 125, 500, 125);
	}
	
	public void update(Graphics g) {
		paint(g);
	}


	public void init() {
		resize(250, 250);
		col = 3;
		col2 = (int) col + 122;
		repaint();
	}

	public boolean mouseMove(java.awt.Event evt, int x, int y) {
		if (x < 250 && y < 250 ) {
			xmouse=x;
			ymouse=y;
			a = (125 - y) * 100;
			b = (x - 125) * 10000;
			a1=(int)a/1250;
			b1=(int)b/125000;
			pot = col * col * col * col + a * col * col + b * col;
			col1 = col + 1;
			pot1 = col1 * col1 * col1 * col1 + a * col1 * col1 + b * col1;
			if (pot1 - pot < 0) {
				sign = 1;
			}
			else {
				sign = -1;
			}
			sign1 = sign;
			while (sign == sign1 && col > -125 && col < 125) {
				sign1 = sign;
				col0 = col ;
				col = col0 + sign1;
				col0 = col1;
				col1 = col0 + sign1 ;
				pot = col * col * col * col + a * col * col + b * col;
				pot1 = col1 * col1 * col1 * col1 + a * col1 * col1 + b * col1;
				if (pot1 - pot < 0 ) {
					sign = 1;
				}
				else {
					sign = -1;
				}
				
			}
			col2=(int) col+125;
			repaint();
		}
		return true;	
	}

	public void mouseEnter() {
		repaint();
	}

	public void mouseExit() {
		repaint();
	}


}
